import java.util.*;

// checker for TwentyFour

public class JohnChecker
{
    public static final int MINN = 4;
	public static final int MAXN = 6;
	public static final int MINV = 1;
	public static final int MAXV = 100;

	public static void printError(int line, String msg)
	{
		System.out.println("ERROR Line " + line + ": " + msg);
		System.exit(-1);
	}

    public static void checkIntBounds(int x, int min, int max, String name, int nLines)
    {
        if (x < min || x > max)
            printError(nLines, "invalid " + name + " value: " + x);
    }

	public static void main(String [] args)
	{
		Scanner in = new Scanner(System.in);
		int n, k, p, m, nLines = 0;
		String line, s="";

        line = in.nextLine();
        nLines++;
        StringTokenizer st = new StringTokenizer(line);
//        n = Integer.parseInt(st.nextToken());
n = 4;
        checkIntBounds(n, MINN, MAXN, "n", nLines);
        if (st.countTokens() != n)
            printError(nLines, "number of values on line incorrect");
        try {
            for(int i=0; i<n; i++) {
                s = st.nextToken();
                int val = Integer.parseInt(s);
                checkIntBounds(val, MINV, MAXV, "value", nLines);
            }
        } catch(NumberFormatException e) {
            printError(nLines, "expected integer, got " + s);
        }
		if (in.hasNextLine())
			printError(nLines, "incorrect number of lines");
    System.exit(42);
	}
}
